﻿// <code-header> 
//   <author>Willem Meints</author> 
//   <copyright>Copyright (c) Willem Meints</copyright> 
// </code-header> 

using System;

namespace FizzyLogic.WebApi.Helpers
{
    /// <summary>
    /// Marks a method parameter as an optional route parameter.
    /// Use this attribute in combination with the <see cref="HttpRouteAttribute"/>
    /// to declare routes that contain optional routing parameters
    /// </summary>
    [AttributeUsage(AttributeTargets.Parameter, AllowMultiple = false, Inherited = true)]
    public class OptionalRouteParameterAttribute : Attribute
    {

    }
}